# update existing packages
BiocManager::install(ask = FALSE)

# install additional packages and dependencies
pkgs <- c("batchelor", "BiocNeighbors", "Biostrings", "BSgenome", "coop", "dplyr", "DropletUtils", "e1071",
          "eisaR", "fishpond", "GenomeInfoDb", "GenomeInfoDbData", "GenomicFeatures", "GenomicRanges",
          "ggplot2", "IRanges", "keras", "knitr", "LoomExperiment", "org.Hs.eg.db", "RColorBrewer",
          "reticulate", "rjson", "rmarkdown", "rsvd", "Rtsne", "scater", "scran", "Seurat",
          "SingleCellExperiment", "SummarizedExperiment", "tensorflow", "tibble", "tidyr", "tximeta")
BiocManager::install(pkgs, ask = FALSE)

# check if required packages have all been installed
ipkgs <- rownames(installed.packages())
if (all(pkgs %in% ipkgs)) {
    message("all required R packges installed successfully")
} else {
    message("ERROR - did not install all required packages. Missing: ", paste(pkgs[! pkgs %in% ipkgs], collapse = ", "))
    quit(save = "no", status = 1, runLast = TRUE)
}

